<?php
/**
 * @file
 * Commerce EU VAT Intra-Community Supply Rules
 */

/**
 * Implements hook_default_rules_configuration().
 */
function commerce_eu_vat_ic_default_rules_configuration() {

  $rule = rules_and(array(
    'commerce_order' => array(
      'label' => t('Commerce Order'),
      'type' => 'commerce_order',
    ),
    'country_list' => array(
      'label' => t('List of Countries'),
      'type' => 'list<text>',
    ),
  ));
  $rule->label = t('Intra-Community Reverse Charge');

  $rule
    ->condition(rules_condition('component_commerce_eu_vat_rules_place_of_supply', array('commerce_order:select' => 'commerce_order', 'country_list:select' => 'country_list'))->negate())
    ->condition('component_commerce_eu_vat_rules_order_has_vat_number', array('commerce_order:select' => 'commerce_order'));

  $rule->negate();

  $configs['commerce_eu_vat_rules_intra_community_reverse_charge'] = $rule;

  return $configs;
}

/**
 * Impliments hook_default_rules_configuration_alter().
 */
function commerce_eu_vat_ic_default_rules_configuration_alter(&$configs) {

  $tax_rates = commerce_tax_rates();

  foreach ($tax_rates as $tax_rate) {
    if ($tax_rate['type'] == 'eu_vat' && isset($configs[$tax_rate['rules_component']])) {
      $country = strtoupper(substr($tax_rate['module'], -2));
      $configs[$tax_rate['rules_component']]
      ->condition('component_commerce_eu_vat_rules_intra_community_reverse_charge', array(
        'commerce_order:select' => 'commerce-line-item:order',
        'country_list' => array($country => $country),
        )
      );
    }
  }
}